wok view syslinux/stuff/iso2exe/taziso @ rev 19324

syslinux: adjust custom conf location
author Pascal Bellard <pascal.bellard@slitaz.org>
date Thu Jul 14 10:28:07 2016 +0200 (2016-07-14)
parents 3432c28d8372
children 31e215a4b9bb
line source
1 #!/bin/sh
3 [ $(id -u) -eq 0 ] || exec su -c "$0 $@"
5 DIALOG=dialog
7 ddq()
8 {
9 dd $@ 2> /dev/null
10 }
12 get()
13 {
14 od -v -j $1 -N ${4:-${3:-2}} -t u${3:-2} -w${3:-2} -An "$2" 2>/dev/null ||
15 hexdump -v -s $1 -n ${4:-${3:-2}} -e "\"\" 1/${3:-2} \" %d\n\"" "$2"
16 }
18 bytes2bin()
19 {
20 for i in $@ ; do
21 printf '\\\\x%02X' $(($i&255))
22 done | xargs echo -en
23 }
25 words2bin()
26 {
27 for i in $@ ; do
28 printf '\\\\x%02X\\\\x%02X' $(($i&255)) $((($i>>8)&255))
29 done | xargs echo -en
30 }
32 gettazboot()
33 {
34 echo "Creating $(basename $1) ..."
35 O=$(($(get 64 "$ISO") - 0xC0))
36 L=$(($(get 20 "$ISO") - 0xC0 - $(get 24 "$ISO") - $O))
37 S=$((32+$L))
38 P=$((($S+511)/512))
39 E=$((4096-(32*$P)))
40 words2bin 0x5A4D $(($S%512)) $P 0 2 $E -1 $((${2:-0}-16)) \
41 -2 0 256 -16 28 0x6C53 0x5469 0x7A61 > $1
42 ddq bs=1 count=$L skip=$(echo $O) if="$ISO" >> $1
43 }
45 uncpio()
46 {
47 [ -s "$1" ] || return
48 echo -en "\n Extracting $(basename $1) ..."
49 case $(get 0 $1) in
50 *35615) ( zcat || gunzip ) ;;
51 *14333) unxz ;;
52 *\ 93) unlzma ;;
53 *) cat ;;
54 esac < $1 | ( cd ${2:-/} ; cpio -idmu > /dev/null 2>&1 )
55 }
57 dotwait()
58 {
59 echo -n "${1:-Install filesystem}.."
60 touch /tmp/wait
61 [ "$REQUEST_URI" ] && return
62 while [ -e /tmp/wait ]; do
63 echo -n "." > /dev/tty
64 sleep 1
65 done &
66 }
68 getuuid()
69 {
70 dev=$(mount | sed "/ $(echo $mnt | sed 's|/|\\/|g') /!d;s/ .*//;s|/dev/||;q")
71 [ "$dev" ] &&
72 blkid | sed "/$dev:/!d;s/.* UUID=.\\([^ ]*\\)\".*/\\1/" ||
73 echo "/dev/hda1"
74 }
76 tazusbinitfs()
77 {
78 PAD=$(($(stat -c %s $1) % 4))
79 [ $PAD -ne 0 ] && ddq if=/dev/zero bs=1 count=$((4 - $PAD)) >> $1
80 mkdir -p /tmp/fs$$/etc /tmp/fs$$/lib /tmp/fs$$/home
81 cp -a /etc/locale.conf /tmp/fs$$/etc 2> /dev/null
82 cp -a /etc/keymap.conf /tmp/fs$$/etc 2> /dev/null
83 cat > /tmp/fs$$/init1 <<EOT
84 #!/bin/sh
85 sed -i 's|sbin/init|init2|' /init
86 exec /init
87 EOT
88 cat > /tmp/fs$$/init2 <<EOT
89 #!/bin/sh
91 mount -t proc /proc /proc
92 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
93 v=\$(sed '/\\/home=/!d;s|.*/home=\\([^ ]*\\).*|\\1|' /proc/cmdline /cmdline 2> /dev/null)
94 mount / -o remount,rw
95 mkdir /mnt/dos
96 rm -f /cmdline 2> /dev/null
97 mount / -o remount,ro
98 mnt=/mnt/dos/\${v#*/}
99 dev=\$( (blkid /dev/[sh]d* || blkid) | grep \${v%%/*} | sed 's/:.*//;q')
100 echo "Mount \$dev in /mnt/dos for \$v..." | tee -a /run/boot.log
101 mount \$dev /mnt/dos
102 if [ ! -d /mnt/dos/slitaz ]; then
103 umount /mnt/dos 2> /dev/null
104 (blkid /dev/[sh]d* || blkid) | while read dev line; do
105 case "\$line" in
106 *ntfs*|*vfat*|*msdos*) ;;
107 *) continue ;;
108 esac
109 mount \${dev%:} /mnt/dos
110 [ -d /mnt/dos/slitaz ] && break
111 umount /mnt/dos
112 done
113 fi
114 $([ "$2" ] || echo '# ')mount.posixovl -F \$mnt -- -oallow_other -odefault_permissions -osuid
115 mount --bind \$mnt /home
116 umount /proc
117 exec /sbin/init
118 EOT
119 chmod 755 /tmp/fs$$/init?
120 ( cd /tmp/fs$$ ; find * | cpio -o -H newc ) | gzip -9 >> $1
121 rm -rf /tmp/fs$$
122 }
124 mkinitrd()
125 {
126 echo -en "\nCreating $(basename $1) "
127 fs=/tmp/fs$$
128 for i in bin lib dev proc tmp mnt etc ; do
129 mkdir -p $fs/$i
130 done
131 for i in /dev/console /dev/null /dev/tty /dev/tty0 /dev/tty1 /dev/tty2 \
132 /dev/fuse /dev/hd* /dev/sd* ; do
133 cp -a $2$i $fs/dev/
134 done
135 for i in /bin/busybox $(which mount.posixovl) $(which blkid); do
136 cp $(LD_TRACE_LOADED_OBJECTS=1 /lib/ld*.so $i | \
137 sed 's|.*=> \(.*/lib/l[^ ]*\).*|\1|;/^\//!d') $fs/lib
138 cp $i $fs/bin
139 done
140 cp -a /lib/ld-* $fs/lib
141 for i in $(busybox | sed '/Current/,$!d'); do
142 [ -e $fs/bin/${i%,} ] || ln -s busybox $fs/bin/${i%,}
143 done
144 ln -s /proc/mounts $fs/etc/mtab
145 sed 's/ .*//' /proc/modules | while read mod ; do
146 find /lib/modules/ | grep $mod.ko | \
147 sed 's|.*|cp & $fs/lib|' | sh
148 done
149 cat > $fs/init <<EOT
150 #!/bin/sh
152 arg()
153 {
154 grep -q \$1 /proc/cmdline &&
155 val="\$(sed "s/.*\$1=\\([^ ]*\\).*/\\1/" < /proc/cmdline)" &&
156 echo "\$2 \$val"
157 }
159 mount -t proc /proc /proc
160 arg debug "shell" && debug=true && set -x
161 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
162 arg mount "Mount device"
163 mount \$( (blkid /dev/[sh]d* || blkid) | grep \$val | sed 's/:.*//;q') /mnt
164 arg subroot "Change root to directory"
165 if [ -d /mnt/\$val ]; then
166 umount /mnt 2> /dev/null
167 (blkid /dev/[sh]d* || blkid) | while read dev line; do
168 case "\$line" in
169 *ntfs*|*vfat*|*msdos*) ;;
170 *) continue ;;
171 esac
172 mount \${dev%:} /mnt
173 [ -d /mnt/\$val ] && break
174 umount /mnt
175 done
176 fi
177 $([ "$3" ] || echo '# ')mount.posixovl -F /mnt/\$val -- -oallow_other -odefault_permissions -osuid
178 mount --bind /mnt /mnt/\$val/mnt/dos
179 mount -o size=0 -t tmpfs tmpfs /mnt/\$val/mnt/dos/\$val
180 LDSO=\$(ls /mnt/\$val/lib/ld-* | sed q)
181 export LD_LIBRARY_PATH=\$val/lib:\$val/usr/lib:/lib
182 [ "$debug" = "true" ] && sh
183 umount /proc
184 exec /bin/switch_root /mnt \${LDSO#/mnt/} \$val/usr/sbin/chroot \$val /sbin/init
185 EOT
186 chmod +x $fs/init
187 ( cd $fs ; find * | cpio -o -H newc ) | lzma e $1 -si 2> /dev/null
188 rm -rf $fs /tmp/wait
189 }
191 ls_r()
192 {
193 ls -r $@ 2> /dev/null || ls $@
194 }
196 doinstall()
197 {
198 unset useposixovl
199 blkid | grep $(df $mnt | sed '$!d;s/ .*/:/') | \
200 grep -qiE "(msdos|vfat|ntfs)" && useposixovl=YES
201 case "$mnt" in
202 *mkzip*) useposixovl=YES
203 esac
204 mkdir -p $mnt/slitaz/boot $mnt/slitaz/mnt/dos
205 [ "$useposixovl" ] &&
206 if ! mount.posixovl -F $mnt/slitaz -- \
207 -oallow_other -odefault_permissions -osuid; then
208 echo "Can't install SliTaz. Abort."
209 sleep 5
210 return 1
211 fi
212 dotwait "Install root filesystem in /slitaz.."
213 if [ "$1" ]; then
214 ls_r $media/boot/rootfs*gz | \
215 xargs cat > $mnt/slitaz/boot/rootfs.gz
216 tazusbinitfs $mnt/slitaz/boot/rootfs.gz $useposixovl
217 initrd=rootfs.gz
218 extraargs="/home=$(getuuid)/slitaz rdinit=/init1"
219 else
220 for i in $(ls_r $media/boot/rootfs*gz); do
221 uncpio $i $mnt/slitaz
222 done
223 for i in $packages_list; do
224 tazpkg get-install $i --root=$mnt/slitaz
225 done
226 for i in $packages_dir/*.tazpkg; do
227 [ -s "$i" ] &&
228 tazpkg install $i --root=$mnt/slitaz
229 done
230 cp -a /etc/locale.conf $mnt/slitaz/etc 2> /dev/null
231 cp -a /etc/keymap.conf $mnt/slitaz/etc 2> /dev/null
232 mkinitrd $mnt/slitaz/boot/initrd $mnt/slitaz $useposixovl
233 initrd=initrd
234 extraargs="mount=$(getuuid) subroot=slitaz"
235 fi
236 echo -en "\nInstall boot files..."
237 for i in $media/boot/bzImage $media/boot/*pxe* \
238 $media/boot/isolinux/he* $media/boot/isolinux/opt* \
239 $media/README $media/boot/memtest* ; do
240 [ -s $i ] && cp $i $mnt/slitaz/boot
241 done
242 for i in $mnt/slitaz/boot/memtest $mnt/slitaz/boot/*pxe* ; do
243 [ $(get 0 $i 2> /dev/null || echo 0) -eq 23117 ] &&
244 mv $i $i.exe
245 done
246 gettazboot $mnt/slitaz/boot/tazboot.exe
247 unix2dos > $mnt/slitaz/boot/tazboot.cmd <<EOT
248 kernel=/slitaz/boot/bzimage
249 initrd=/slitaz/boot/$initrd
250 rw root=/dev/null $extraargs autologin
251 EOT
252 unix2dos $mnt/slitaz/boot/he* $mnt/slitaz/boot/opt* \
253 $mnt/slitaz/boot/README
254 [ -d $mnt/slitaz/usr/sbin -a ! -x $mnt/slitaz/usr/sbin/mount.posixovl ] &&
255 cp $(which mount.posixovl) $mnt/slitaz/usr/sbin
256 if [ "$useposixovl" ] && grep -qs " $mnt " /proc/mounts &&
257 [ ! -d $mnt/boot/grub ]; then
258 mkdir -p $mnt/boot/grub
259 echo -en "\nInstall grub in /boot/grub..."
260 cp -a /usr/lib/grub/*/* $mnt/boot/grub
261 cat > $mnt/boot/grub/menu.lst <<EOT
262 # /boot/grub/menu.lst: GRUB boot loader configuration.
264 # By default, boot the first entry.
265 default 0
267 # Boot automatically after 8 secs.
268 timeout 8
270 title Microsoft Windows
271 chainloader +1
273 EOT
274 dev=$(grep " $mnt " /proc/mounts | awk '{ print $1 }')
275 base=${dev//[0-9]/}
276 dd if=$base bs=32k count=1 of=$mnt/boot/grub/$(basename $base)
277 cat > $mnt/boot/grub/uninstall-grub.sh <<EOT
278 #!/bin/sh
280 [ -s /boot/grub/$(basename $base) ] &&
281 dd if=/boot/grub/$(basename $base) of=$base
282 EOT
283 grub-install --no-floppy --root-directory=$mnt $base
284 fi
285 if [ -s $mnt/boot/grub/menu.lst ] &&
286 ! grep -q /slitaz/boot/bzimage $mnt/boot/grub/menu.lst; then
287 echo -en "\nUpdate /boot/grub/menu/lst..."
288 cat >> $mnt/boot/grub/menu.lst <<EOT
289 title SliTaz GNU/Linux $(cat $mnt/slitaz/etc/slitaz-release)
290 kernel /slitaz/boot/bzimage rw root=/dev/null $extraargs autologin
291 initrd /slitaz/boot/$initrd
293 EOT
294 fi
295 rm -f /tmp/wait
296 [ "$useposixovl" ] && umount $mnt/slitaz
297 return 0
298 }
300 windev()
301 {
302 if [ -b "$1" ]; then
303 device=$1
304 elif [ "$1" ]; then
305 echo "Invalid Linux/Windows partition"
306 return 1
307 else
308 DEV="$(blkid | grep -iE "(msdos|vfat|ntfs|ext[234]|xfs|btrfs)" | sed 's/:.*//;s|/dev/||')"
309 [ "$DEV" ] || return
310 cat > /tmp/dialog$$ <<EOT
311 $DIALOG --clear \
312 --title " Select your Linux/Windows partition " \
313 --menu "\nPlease select the Linux/Windows partition according to its known size.
314 The data will be kept untouched.\n" \
315 17 70 8 \
316 $(for i in $DEV ; do
317 label="$(blkid | sed "/$i:/!d;s/.*://;s/[^ ]*UUID=[^ ]* //g;s/LABEL=//")"
318 echo -n "/dev/$i \"$(($(cat /sys/block/*/$i/size)/2048))MB $label\" "
319 done)
320 EOT
321 exec 3>&1
322 [ $? -eq 0 ] || return
323 device=$(. /tmp/dialog$$ 2>&1 1>&3)
324 exec 3>&-
325 rm -f /tmp/dialog$$
326 fi
327 mnt=/tmp/mnt$$
328 mkdir -p $mnt && mount $device $mnt
329 }
331 extra_packages()
332 {
333 packages_list=
334 packages_dir=
335 $DIALOG --clear \
336 --title " Extra packages " \
337 --defaultno --yesno \
338 "
339 Do you want to add extra packages ?
340 " 7 70
341 [ $? -eq 0 ] || return
342 [ -s /var/lib/tazpkg/packages.txt ] || tazpkg recharge
343 if [ -s $media/boot/vmlinuz-$(uname -r) ]; then
344 cat > /tmp/dialog$$ <<EOT
345 $DIALOG --clear \
346 --title " Select the packages " \
347 --separate-output \
348 --cancel-label "Skip" \
349 --checklist "Please select the packages you want to install. Try with the first letter." \
350 0 0 0 \\
351 EOT
352 awk -F\| '{ printf "%s \"%s\" off ",$1,$3 }' \
353 /var/lib/tazpkg/packages.desc >> /tmp/dialog$$
354 sh /tmp/dialog$$ 2> /tmp/dialog.out$$
355 [ $? -eq 0 ] && packages_list="$(cat /tmp/dialog.out$$)"
356 fi
357 cat > /tmp/dialog$$ <<EOT
358 $DIALOG --clear \
359 --title "Please select the directory with every custom package to install." \
360 --cancel-label "Skip" \
361 --dselect $PWD 13 78
362 EOT
363 sh /tmp/dialog$$ 2> /tmp/dialog.out$$
364 [ $? -eq 0 ] && packages_dir="$(cat /tmp/dialog.out$$)"
365 rm -f /tmp/dialog$$ /tmp/dialog.out$$
366 }
368 _install()
369 {
370 extra_packages
371 $DIALOG --clear \
372 --title " SliTaz UMSDOS way installation " \
373 --yes-label "Install" --yesno \
374 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
375 Linux/DOS/Windows partition. You can see your files from /mnt/dos.\n\n
376 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
377 To uninstall SliTaz, you have only to remove this directory.
378 The file \\boot.ini or \\config.sys may be modified too.\n\n
379 SliTaz may run slowly on 'UMSDOS way' installation due to the
380 posixovl filesystem. The 'TAZUSB way' installation runs faster.\n\n
381 To do a traditional installation with disk partitioning,
382 start SliTaz Live with 'SliTaz RAM boot' menu.\n
383 " 19 70
384 [ $? -eq 0 ] || return
385 doinstall
386 }
388 readtazbootconf()
389 {
390 kernel="$(sed '/^kernel=/!d;s/.*=//' $mnt/slitaz/boot/tazboot.cmd)"
391 initrd="$(sed '/^initrd=/!d;s/.*=//' $mnt/slitaz/boot/tazboot.cmd)"
392 cmdline="$(sed '/^kernel=/d;/^initrd=/d' $mnt/slitaz/boot/tazboot.cmd)"
393 }
395 bootinstalled()
396 {
397 [ "$(which kexec)" ] || return
398 [ -x $mnt/slitaz$1 ] || return
399 [ -s $mnt/slitaz/boot/tazboot.cmd ] || return
400 readtazbootconf
401 kexec -l $kernel --initrd $initrd --command-line "$cmdline" || return
402 umount $mnt
403 rm -rf $mnt
404 quit "kexec -e"
405 }
407 mkzip()
408 {
409 device=
410 packages_list=
411 packages_dir=
412 mnt=/tmp/mkzipmnt$$
413 mkdir -p $mnt
414 $1 $2 || return
415 for i in bootlace.com grubinst.exe grldr ; do
416 wget -O $mnt/slitaz/boot/$i http://mirror.slitaz.org/boot/$i
417 done
418 readtazbootconf
419 cat > $mnt/slitaz/boot/menu.lst <<EOT
420 title SliTaz
421 kernel $kernel $cmdline
422 initrd $initrd
424 EOT
425 while read file title; do
426 file=$(ls $mnt/slitaz/boot/*$file* 2> /dev/null)
427 [ -s "$file" ] && cat >> $mnt/slitaz/boot/menu.lst <<EOT
428 title $title
429 kernel ${file#$mnt}
431 EOT
432 done <<EOT
433 memtest MemTest
434 pxe Web boot
435 EOT
436 unix2dos $mnt/slitaz/boot/menu.lst
437 unix2dos > $mnt/slitaz/boot/install.txt <<EOT
438 For DOS users (real mode only):
440 Start SliTaz with \\slitaz\\boot\\tazboot.exe
443 For NT/2000/XP users:
445 1- Move the files grldr and menu.lst into the root directory
447 C:\\> copy \\slitaz\\boot\\grldr \\
448 C:\\> copy \\slitaz\\boot\\menu.lst \\
450 2- Remove boot.ini attributes
452 C:\\> attrib -r -h -s boot.ini
454 3- Append the following line to boot.init
456 C:\\grldr="slitaz"
458 4- Restore boot.ini attributes
460 C:\\> attrib +r +h +s boot.ini
462 See http://diddy.boot-land.net/grub4dos/files/README_GRUB4DOS.txt
463 and http://xpt.sourceforge.net/techdocs/nix/disk/boot/boot07-GrubForDosInfo/ar01s03.html
464 EOT
465 ( cd $mnt ; echo 'See \slitaz\boot\install.txt to launch SliTaz.' | \
466 zip -zr9 $(basename "$ISO" .iso).zip slitaz )
467 [ "$(which advzip)" ] &&
468 echo "Recompressing $(basename "$ISO" .iso).zip ..." &&
469 advzip -z4 $mnt/*.zip
470 mv $mnt/*.zip .
471 du -h $PWD/$(basename "$ISO" .iso).zip
472 umount $mnt
473 rm -rf $mnt
474 }
476 install()
477 {
478 windev $1 || return
479 packages_list=
480 packages_dir=
481 if [ "$1" ]; then
482 doinstall
483 else
484 _install && bootinstalled /sbin/init
485 fi
486 umount $mnt
487 rm -rf $mnt
488 }
490 inst2zip()
491 {
492 if [ "$1" ]; then
493 mkzip doinstall
494 else
495 mkzip _install
496 fi
497 }
499 _installtaz()
500 {
501 $DIALOG --clear \
502 --title " SliTaz TAZUSB way installation " \
503 --yes-label "Install" --yesno \
504 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
505 Linux/DOS/Windows partition. You can see your files from /mnt/dos.\n\n
506 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
507 To uninstall SliTaz, you have only to remove this directory.
508 The file \\boot.ini or \\config.sys may be modified too.\n\n
509 The filesystem is loaded entirely into memory upon boot to
510 increase responsiveness. Only /home lands on hard disk.\n\n
511 To do a traditional installation with disk partitioning,
512 start SliTaz Live with 'SliTaz RAM boot' menu.\n
513 " 19 70
514 [ $? -eq 0 ] || return
515 doinstall tazusblike
516 }
518 installtaz()
519 {
520 windev $1 || return
521 packages_list=
522 packages_dir=
523 if [ "$1" ]; then
524 doinstall tazusblike
525 else
526 _installtaz && bootinstalled /boot/bzimage
527 fi
528 umount $mnt
529 rm -rf $mnt
530 }
532 insttaz2zip()
533 {
534 if [ "$1" ]; then
535 mkzip doinstall tazusblike
536 else
537 mkzip _installtaz
538 fi
539 }
541 bootiso()
542 {
543 cd /tmp
544 for i in $(ls_r $media/boot/rootfs*gz); do
545 grep -q ' lm ' /proc/cpuinfo && [ -s ${i}64 ] && i=${i}64
546 cat $i
547 n=$((4 - ($(stat -c %s $i) % 4)))
548 [ $n -eq 4 ] || dd if=/dev/zero bs=1 count=$n
549 done > initrd$$
550 cmdline="root=/dev/null autologin lang=$LANG"
551 [ -s /etc/keymap.conf ] && cmdline="$cmdline kmap=$(cat /etc/keymap.conf)"
552 [ -s /etc/TZ ] && cmdline="$cmdline tz=$(cat /etc/TZ)"
553 rm -f cmdline initrd 2> /dev/null
554 getcustomconf kexec >/dev/null
555 [ -s cmdline ] && cmdline="$cmdline $(cat cmdline)" && rm cmdline
556 [ -s initrd ] && cat initrd >> initrd$$ && rm initrd
557 kernel=$media/boot/bzImage
558 grep -q ' lm ' /proc/cpuinfo && [ -s ${kernel}64 ] && kernel=${kernel}64
559 . /etc/locale.conf
560 kexec -l $kernel --initrd initrd$$ --command-line "$cmdline" &&
561 rm -f initrd$$
562 quit "kexec -e"
563 }
565 tazboot()
566 {
567 if [ -z "$1" ]; then
568 $DIALOG --clear \
569 --title " SliTaz bootloader for DOS " \
570 --yes-label "Install" --yesno \
571 "\nThe file TAZBOOT.EXE will be created in the top directory. It supports
572 any linux kernel, multiple initramfs, a kernel command line and
573 an ISO image file loopback (retrieves files from an ISO file).\n\n
574 Usage: tazboot.exe [[@commands]|[kernel=<bzimage>]
575 [initrd=<rootfs>[,<rootfs2>...]] [bootfrom=<isofile>] cmdline args ...]\n\n
576 Defaults: tazboot @tazboot.cmd or tazboot kernel=bzImage auto\n\n\
577 Examples for tazboot.cmd:\n\n\
578 bootfrom=\\isos\\slitaz-4.0.iso\n\
579 kernel=boot/bzImage\n\
580 initrd=boot/rootfs4.gz,boot/rootfs3.gz,boot/rootfs2.gz,boot/rootfs1.gz\n\
581 rw root=/dev/null autologin\n\n\
582 kernel=\\slitaz\\vmlinuz root=/dev/sda5 ro\n\n
583 Unlike GRUB4DOS, it doesn't require unfragmented ISO image files.\n
584 " 0 0
585 [ $? -eq 0 ] || return
586 fi
587 gettazboot tazboot.exe
588 du -h $PWD/tazboot.exe
589 }
591 md5()
592 {
593 dotwait "Checking files"
594 ( cd $media ; ${md5sum:-md5sum -c md5sum*} | sort ) > /tmp/data
595 unset md5sum
596 rm -f /tmp/wait
597 if [ "$1" ]; then
598 cat /tmp/data
599 else
600 $DIALOG --clear \
601 --title " Checked files " \
602 --textbox /tmp/data 0 0
603 fi
604 rm -f /tmp/data
605 }
607 gotcdfile()
608 {
609 for i in "$media/$1" "$media/*/$1" "$media/*/isolinux/$1" ; do
610 file=$(ls $i 2> /dev/null | sed q)
611 [ -s "$file" ] && break
612 done
613 }
615 sha()
616 {
617 gotcdfile 'sha*sum*'
618 sha=$(basename $file)
619 md5sum="${sha%sum*}sum -c ${file#$media/}"
620 md5 $@
621 }
623 readme()
624 {
625 gotcdfile 'README*'
626 if [ "$1" ]; then
627 cat $file
628 else
629 $DIALOG --clear \
630 --title " Readme " \
631 --textbox $file 0 0
632 fi
633 }
635 bzimage()
636 {
637 if [ -z "$1" ]; then
638 $DIALOG --clear \
639 --title " Create linux.exe ? " \
640 --yes-label "Install" --yesno \
641 "\nLinux.exe launches the linux kernel under DOS (in real mode only).
642 The cmdline arguments are supported except initrd=,
643 vga= (you can try 'rdev -v') and mem= (partially).
644 \nExample:\nC:\\> linux.exe root=/dev/hda2 ro panic=60\n
645 " 12 70
646 [ $? -eq 0 ] || return
647 fi
648 cp $media/boot/bzImage linux.exe
649 du -h $PWD/linux.exe
650 }
652 memtest()
653 {
654 if [ -z "$1" ]; then
655 $DIALOG --clear \
656 --title " Create memtest.exe ? " \
657 --yes-label "Install" --yesno \
658 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
659 computers. BIOS based memory tests are a quick, cursory check and often
660 miss many of the failures that are detected by Memtest86.\n
661 " 0 0
662 [ $? -eq 0 ] || return
663 fi
664 gotcdfile 'memtest*' && cp $file memtest.exe
665 du -h $PWD/memtest.exe
666 }
668 mkfat12()
669 {
670 [ $(($(get 0 $1) - 0x5A4D)) -eq 0 ] || return
671 J=$(($(get 3 $1 1) + 0x02))
672 R=$((1 + $(get 497 $1 1) + 1 + ($(get 500 $1)-1)/32))
673 [ $R -lt 2500 ] || return
674 [ $((($(get 500 $1)-1) & 31)) -lt 30 ] &&
675 ddq if=$file bs=32 count=1 seek=$(($R*16 - 1)) of=/dev/fd0
676 G="18 0 2 0 0 0 0 0"
677 [ $J -gt 25 ] || G=""
678 F=0
679 for i in 1 2 3; do
680 F=$((((2880-$R-$F-$F)*3+1023)/1024))
681 done
682 bytes2bin 0xEB $J 0x90 0x20 0x20 0x20 0x20 0x20 0x20 0x20 0x20 \
683 0 2 2 $(($R%256)) $(($R/256)) 2 64 0 64 11 0xF0 $F 0 \
684 $G | ddq bs=1 of=/dev/fd0
685 ddq if=/dev/zero bs=512 count=$((4+$F+$F)) seek=$R of=/dev/fd0
686 for i in $R $(($R+$F)) ; do
687 bytes2bin 0xF0 0xFF 0xFF | ddq bs=512 seek=$i of=/dev/fd0
688 done
689 echo -n $(basename $1) | ddq bs=1 seek=3 count=8 of=/dev/fd0
690 }
692 mkfloppy()
693 {
694 dotwait "Create a $(basename $1) boot floppy"
695 ddq if=$1 of=/dev/fd0
696 mkfat12 $1
697 rm -f /tmp/wait
698 }
700 fdmemtest()
701 {
702 if [ -z "$1" ]; then
703 $DIALOG --clear \
704 --title " Create a Memtest86 boot floppy " \
705 --yes-label "Create floppy" --yesno \
706 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
707 computers. BIOS based memory tests are a quick, cursory check and often
708 miss many of the failures that are detected by Memtest86.\n\n
709 Please insert a blank disk in floppy drive.\n
710 " 0 0
711 [ $? -eq 0 ] || return
712 fi
713 gotcdfile 'memtest*' && mkfloppy $file
714 }
716 pxe()
717 {
718 gotcdfile '?pxe'
719 if [ -z "$1" ]; then
720 $DIALOG --clear \
721 --title " Create $(basename $file).exe ? " \
722 --yes-label "Install" --yesno \
723 "\nBoot your operating system from the internet and enjoy a full system
724 working entirely in RAM with speed and stability in mind. The Linux Kernel
725 and the complete SliTaz compressed root filesystem will be loaded into RAM
726 from the Web using PXE and HTTP protocols.\n
727 " 0 0
728 [ $? -eq 0 ] || return
729 fi
730 cp $file $(basename $file).exe
731 du -h $PWD/$(basename $file).exe
732 }
734 fdpxe()
735 {
736 if [ -z "$1" ]; then
737 $DIALOG --clear \
738 --title " Create a SliTaz Web boot floppy " \
739 --yes-label "Create floppy" --yesno \
740 "\nBoot your operating system from the internet and enjoy a full system
741 working entirely in RAM with speed and stability in mind. The Linux Kernel
742 and the complete SliTaz compressed root filesystem will be loaded into RAM
743 from the Web using PXE and HTTP protocols.\n\n
744 Please insert a blank disk in floppy drive.\n
745 " 0 0
746 [ $? -eq 0 ] || return
747 fi
748 gotcdfile '?pxe' && mkfloppy $file
749 }
751 menuitem()
752 {
753 [ "$3" ] && shift
754 echo -en "\"$1\" \"$2\""
755 }
757 gotposixovl()
758 {
759 mount.posixovl 2>&1 | grep -qi usage && menuitem "$@"
760 }
762 gotposixovlzip()
763 {
764 [ "$(which zip)" ] && gotposixovl "$1" "$2"
765 }
767 xfile()
768 {
769 [ "$(which $1)" ] && menuitem "$@"
770 }
772 cdfile()
773 {
774 gotcdfile "$1" && menuitem "$@"
775 }
777 isbzImage()
778 {
779 [ $(get 514 $file 4) -eq 1400005704 ] &&
780 [ $(($(get 529 $file 1) & 1)) -eq 1 ]
781 }
783 cdfilex()
784 {
785 gotcdfile "$1" && [ "$(which kexec)" ] && isbzImage && menuitem "$@"
786 }
788 cdfilef()
789 {
790 [ -e /sys/block/fd0 ] && cdfile "$@"
791 }
793 cdexe()
794 {
795 gotcdfile "$1" &&
796 [ $(get 0 $file 2>/dev/null || echo 0) -eq 23117 ] &&
797 menuitem "$@"
798 }
800 misspkg()
801 {
802 for i in zip kexec-tools posixovl cdrkit cdrkit-isoinfo ; do
803 [ -d /var/lib/tazpkg/installed/$i/ ] && continue
804 [ "$1" != "install" ] && menuitem "$@" && return
805 tazpkg get-install $i
806 done
807 }
809 missing()
810 {
811 misspkg install
812 }
814 ishybrid()
815 {
816 [ $(get 510 "$ISO") -eq 43605 ] || return
817 C=$((2048*$(get $(((17*2048) + 71)) "$ISO" 4)))
818 [ $(get $C "$ISO" 4) -eq 1 ] || return
819 [ $(get $(($C+30)) "$ISO" 4) -eq $((0x88AA55)) ] || return
820 C=$((2048*$(get $(($C+40)) "$ISO" 4)))
821 [ $(get $(($C+64)) "$ISO" 4) -eq 1886961915 ] && menuitem "$@"
822 }
824 isiso()
825 {
826 [ $(get 32769 "$ISO" 4) -eq 808469571 ] && menuitem "$@"
827 }
829 hastazboot()
830 {
831 [ $(get 0 "$ISO") -eq 23117 ] && menuitem "$@"
832 }
834 burnable()
835 {
836 [ "$(sed '/Can wr.*1$/!d' /proc/sys/dev/cdrom/info)" ] && menuitem "$@"
837 }
839 blankable()
840 {
841 [ "$(sed '/Can wr.*RW.*1$/!d' /proc/sys/dev/cdrom/info)" ] && menuitem "$@"
842 }
844 burniso()
845 {
846 wodim -v speed=$(fgrep "drive speed" /proc/sys/dev/cdrom/info | cut -f3) \
847 -eject -multi "$ISO"
848 }
850 blankcd()
851 {
852 wodim -v -blank=fast
853 }
855 customsector()
856 {
857 local c=$(echo $(get 32848 "$ISO" 4))
858 hascustomconf $(($c+16)) && echo $(($c+16)) || echo $c
859 }
861 hascustomconf()
862 {
863 [ "$(ddq bs=2k skip=${1:-$(customsector)} if="$ISO" | ddq bs=1 count=6)" \
864 == "#!boot" ]
865 }
867 gotcustomconf()
868 {
869 hascustomconf && menuitem "$@"
870 }
872 gotisomd5()
873 {
874 [ "$(which md5sum 2> /dev/null)" ] &&
875 [ $(get 0 "$ISO") -eq 23117 ] &&
876 [ $(get 18 "$ISO") -ne 0 ] && menuitem "$@"
877 }
879 getcustomconf()
880 {
881 ddq bs=2k skip=$(customsector) if="$ISO" | while read line; do
882 case "$line" in
883 \#!boot*) ;;
884 append=*) echo ${line#append=} > cmdline && ls -l $PWD/cmdline ;;
885 initrd:*) cnt=${line#initrd:}
886 { ddq bs=512 count=$(($cnt / 512));
887 ddq bs=1 count=$(($cnt % 512)); } > initrd &&
888 ls -l $PWD/initrd
889 break ;;
890 *) break ;;
891 esac
892 done
893 [ "$1" ] && return 0
894 echo -e "\rPress RETURN to continue."
895 read n
896 }
898 isomd5()
899 {
900 dotwait "Checking iso image"
901 [ "$(ddq if="$ISO" bs=2k skip=16 \
902 count=$(($(get 32848 "$ISO" 4)-16)) | md5sum)" == \
903 "$(ddq if="$ISO" bs=16 count=1 skip=2047 | od -N 16 -t x1 -An | \
904 sed 's/ //g') -" ] && echo "OK" || echo "ERROR"
905 echo -en "\rChecking iso hybrid boot..."
906 n=$(($(get 2 "$ISO")-1+($(get 4 "$ISO")-1)*512))
907 if [ $n -lt 40000 -a $n -gt 32768 ]; then
908 s=$(get 0 "$ISO" 2 $n | awk '{ i+= $0 } END { print i }')
909 [ $(((1+$s+$(get $(($n+1)) "$ISO" 1)) % 65536)) -eq 0 ] &&
910 echo "OK" || echo "ERROR"
911 fi
912 if hascustomconf; then
913 echo -en "\rChecking iso custom config..."
914 TMP=/tmp/$(basename $0)$$md5
915 md5="$(ddq bs=2k skip=$(customsector) if="$ISO" | while read line; do
916 case "$line" in
917 \#!boot*) echo ${line#*boot } > $TMP ;;
918 append=*) echo $line ;;
919 initrd:*) echo $line
920 cnt=${line#initrd:}
921 ddq bs=512 count=$((cnt / 512))
922 ddq bs=1 count=$((cnt % 512))
923 break ;;
924 *) break ;;
925 esac
926 done | md5sum | cut -c1-32)"
927 [ "$md5" == "$(cat $TMP)" ] && echo "OK" || echo "ERROR"
928 rm -f $TMP
929 fi
930 rm -f /tmp/wait
931 [ "$1" ] && return 0
932 echo -e "\rPress RETURN to continue."
933 read n
934 }
936 usbdev()
937 {
938 dotwait "Wait 5 seconds for USB devices"
939 sleep 5
940 rm -f /tmp/wait
941 DEV="$(grep -l 1 /sys/block/*/removable | \
942 sed 's|/sys/block/\(.*\)/removable|\1|')"
943 grep -qs 1 /sys/block/$DEV/ro && return
944 [ "$DEV" ] || return
945 cat > /tmp/dialog$$ <<EOT
946 $DIALOG --clear \
947 --title " Select your USB key " \
948 --menu "\nPlease select the USB key according to its known size.\n\n" \
949 0 0 0 \
950 $(for i in $DEV ; do
951 echo -n "/dev/$i \"$(($(cat /sys/block/$i/size)/2048))MB $(cat /sys/block/$i/device/model 2> /dev/null)\" "
952 done) \
954 EOT
955 exec 3>&1
956 device=$(. /tmp/dialog$$ 2>&1 1>&3)
957 rm -f /tmp/dialog$$
958 retval=$?
959 exec 3>&-
960 rm -f /tmp/dialog$$
961 [ $retval -eq 0 ]
962 }
964 tazusbmsg()
965 {
966 [ "$(which tazusb 2> /dev/null)" ] || return
967 echo "You should choose 'USB key read/write installation' to be
968 able to save the package updates or your own configuration and data files.\n\n"
969 }
971 usbbootkey()
972 {
973 if [ -b "$1" ]; then
974 device=$1
975 elif [ "$1" ]; then
976 echo "Invalid USB key device"
977 return 1
978 else
979 $DIALOG --clear \
980 --title " Create a USB boot key " \
981 --yes-label "Continue" --yesno \
982 "\nThe USB key will be used like a CD-ROM. You will not be able to write
983 any data on the boot partition.\n\n
984 An extra FAT32 partition will be created with the remaining free space.\n\n
985 $(tazusbmsg)Please plug your USB stick in now.\n
986 " 16 70
987 [ $? -eq 0 ] || return
988 usbdev || return
990 # perform dd in progress bar
991 max=$(($(stat -c %s "$ISO")/2048))
992 i=0; ddq if="$ISO" bs=1024k | (
993 while ddq bs=1024k count=1 ; do
994 i=$(($i + 1))
995 [ $i -gt $max ] && break
996 echo $((($i*100)/$max)) | dialog --gauge \
997 " The ISO image transfer can be long. Please wait..." \
998 6 70 0 > /dev/tty 2>&1
999 done ) > $device
1000 fi
1002 # partition + fat32 format for the remaining space
1003 for p in 0 16; do
1004 get $((450+$p)) $device 2 12 | xargs echo | {
1005 read dx cx ol oh ll lh
1006 [ $dx -eq $((0x3F17)) ] || continue
1007 cx=$(($cx & 0xFF00))
1008 ofs=$(($ll+($lh<<16)))
1009 n=$(($(cat /sys/block/${device#/dev/}/size)-$ofs))
1010 m=$(($cx+($n/8)))
1011 [ $m -gt $((0x3FF00)) ] && m=$((0x3FF00))
1012 m=$((($m & 0xFF00)+(($m>>16)<<6)))
1013 words2bin 0 $((0x101+$cx)) 0x3F0B $((32+$m)) \
1014 $ll $lh $(($n & 0xFFFF)) $(($n >> 16)) | \
1015 ddq bs=1 seek=$((462-$p)) of=$device
1016 if [ "$(which mkdosfs 2> /dev/null)" ]; then
1017 losetup -o $((512*$ofs)) /dev/loop2 $device
1018 mkdosfs -n "SLITAZ BOOT" /dev/loop2
1019 words2bin $(($ofs & 0xFFFF)) $(($ofs >> 16)) | \
1020 ddq bs=1 seek=28 of=/dev/loop2
1021 sync
1022 losetup -d /dev/loop2
1023 fi
1025 done
1028 usbkey()
1030 $DIALOG --clear \
1031 --title " Create a SliTaz USB key " \
1032 --yes-label "Continue" --yesno \
1033 "\nUnlike a hard drive install, the filesystem is kept in a compressed
1034 rootfs.gz. The filesystem is loaded entirely into memory upon boot.
1035 This should increase responsiveness, protect the filesystem against
1036 accidental corruption and reduce read/writes to the USB drive.
1037 Once setup, the tazusb utility can rewrite the root filesystem
1038 with any changes you have made since booting up,
1039 giving the effective benefits of a hard drive install.\n\n
1040 /home is mounted on boot using the UUID of your particular flash drive.
1041 Unlike a device name, the UUID has the benefit of never changing from machine
1042 to machine.\n\n
1043 Please plug your USB stick in now.\n
1044 " 19 70
1045 [ $? -eq 0 ] || return
1046 usbdev || return
1047 exec 3>&1
1048 format=`$DIALOG --clear \
1049 --title " Select the filesystem " \
1050 --radiolist "\nPlease select the filesystem type to create.\n\n\
1051 The filesystem creation will erase all the data \
1052 in the USB key." 14 70 4 \
1053 "none" "Do not erase the USB key" on \
1054 "ext3" "Ext3 journaling filesystem" off \
1055 "ext2" "Ext2 filesystem" off \
1056 "fat32" "Windows FAT32 filesystem" off \
1057 2>&1 1>&3`
1058 retval=$?
1059 exec 3>&-
1060 [ $retval -eq 0 ] || return
1061 [ "$format" != "none" ] && tazusb format $device "SliTaz" $format
1062 tazusb gen-iso2usb "$ISO" $device
1065 dokexec()
1067 kexec -l $file || return
1068 quit "kexec -e"
1071 runmemtest()
1073 gotcdfile 'memtest*' && dokexec
1076 runpxe()
1078 gotcdfile '?pxe' && dokexec
1081 flavdata()
1083 [ $(get 1024 "$ISO") -eq 35615 ] && n=2 || n=$((1+$(get 417 "$ISO" 1)))
1084 dd if="$ISO" bs=512 skip=$n count=20 2>/dev/null | zcat 2>/dev/null
1087 hasflavinfo()
1089 [ "$(flavdata | dd bs=1 count=8 2> /dev/null | strings)" == \
1090 "07070100" ] && menuitem "$@"
1093 showfavinfo()
1095 mkdir -p /tmp/data
1096 flavdata | ( cd /tmp/data ; cpio -i )
1097 file=/tmp/data/info
1098 cat /tmp/data/*desc > $file
1099 if [ -s /tmp/data/*receipt ]; then
1100 echo "=== receipt ==="
1101 cat /tmp/data/*receipt
1102 fi >> $file
1103 for i in /tmp/data/*list* ; do
1104 echo "=== extra ${i#*list} files"
1105 cat $i
1106 done >> $file
1107 if [ "$1" ]; then
1108 cat $file
1109 else
1110 $DIALOG --clear \
1111 --title " Flavor info " \
1112 --textbox $file 0 0
1113 fi
1114 rm -rf /tmp/data
1117 flavor()
1119 name="$(flavdata | cpio -t 2> /dev/null | sed 's/.[a-z]*$//;q')"
1120 echo "Create ${name:=flavor}.flavor..."
1121 tazlito iso2flavor "$ISO" $name
1122 ls -l $name.flavor 2> /dev/null && return
1123 sleep 5
1124 [ "$1" ] && return
1125 echo -e "\rPress RETURN to continue."
1126 read n
1129 if [ "$1" == "--build" ]; then #install-begin
1130 uuencode -m - < ifmem.bin | sed -e '/^ifmemcode$/r/dev/stdin' \
1131 -e '/^ifmemcode$/d' -i $0
1132 uuencode -m - < bootloader.bin | sed -e '/^bootloader$/r/dev/stdin' \
1133 -e '/^bootloader$/d' -e '/install-begin$/,/install-end$/d' -i $0
1134 exit
1135 fi #install-end
1136 parse_isolinux()
1138 awk 'BEGIN { IGNORECASE=1 }
1139 function multi(n)
1141 auto=$n
1142 for (--n; n < NF; n+=2) {
1143 s=$n
1144 if (s ~ /M$/) s = substr(s,0,length(s)-1)
1145 else s /= 1024
1146 sizes=int(s) " " sizes
1148 next
1151 if ($1 == "LABEL") {
1152 label=$2
1153 if (auto == "") auto=label
1155 if ($1 == "KERNEL" || $1 == "COM32") kernel[label]=$2
1156 if ($1 == "INITRD") initrd[label]=$2
1157 if ($1 == "APPEND") {
1158 i=2
1159 if (kernel[label] ~ "ifmem.c32") multi(3)
1160 if (kernel[label] ~ "c32box.c32") {
1161 if ($2 == "linux") { kernel[label]=$3; i=4 }
1162 if ($2 == "ifmem") multi(4)
1164 if (kernel[label] ~ "ifcpu64.c32") { auto=$4; next }
1165 while (i <= NF) {
1166 if ($i ~ "^initrd=") initrd[label]=substr($i,8)
1167 else cmdline[label]=cmdline[label] " " $i
1168 i++
1172 END {
1173 print "KERNEL=\"" kernel[auto] "\""
1174 print "INITRD=\"" initrd[auto] "\""
1175 print "CMDLINE=\"" substr(cmdline[auto],2) "\""
1176 print "SIZES=\"" sizes "\""
1177 }'
1180 locase()
1182 echo "$1" | tr [A-Z] [a-z]
1185 ifmemcode()
1187 uudecode <<EOT
1188 ifmemcode
1189 EOT
1192 floppyset()
1194 gotcdfile isolinux.cfg
1195 parse_isolinux < $file > /tmp/var$$
1196 . /tmp/var$$
1197 for i in $media/$KERNEL $(dirname $file)/$KERNEL $media/$(locase $KERNEL) \
1198 $(dirname $file)/$(locase $KERNEL); do
1199 [ -s $i ] && KERNEL=$i && break
1200 done
1201 rm -f /tmp/var$$
1202 [ $(get 514 $KERNEL 4) -eq 1400005704 ] || return
1203 n=$(($(get 497 $KERNEL 1)+1))
1204 ddq bs=512 count=$n if=$KERNEL of=/tmp/fd$$
1205 uudecode <<EOT | ddq of=/tmp/fd$$ conv=notrunc
1206 bootloader
1207 EOT
1208 pos=$(($n*512))
1209 if [ -n "$CMDLINE" ]; then
1210 echo -n "$CMDLINE" | ddq bs=512 count=1 conv=sync >> /tmp/fd$$
1211 bytes2bin $n | ddq conv=notrunc \
1212 bs=1 seek=497 count=1 of=/tmp/fd$$
1213 words2bin $pos | ddq conv=notrunc \
1214 bs=1 seek=34 count=2 of=/tmp/fd$$
1215 [ $(get 518 $KERNEL 4) -ge 514 ] &&
1216 words2bin 32768 9 | ddq conv=notrunc \
1217 bs=1 seek=552 count=4 of=/tmp/fd$$
1218 fi
1219 syssize=$(echo $(get 500 /tmp/fd$$ 4))
1220 ddq bs=512 skip=$n if=$KERNEL | cat - /dev/zero | \
1221 ddq bs=512 count=$((($syssize+31)/32)) conv=sync >> /tmp/fd$$
1222 base=$(stat -c %s /tmp/fd$$)
1223 len=
1224 if [ "$INITRD" ]; then
1225 l=0
1226 for i in ${INITRD//,/ }; do
1227 for j in $media/$i $(dirname $KERNEL)/$i $media/$(locase $i) \
1228 $(dirname $KERNEL)/$(locase $i); do
1229 [ -s $j ] && i=$j && break
1230 done
1231 ddq if=$i >> /tmp/fd$$
1232 l=$(($l+$(stat -c %s $i)))
1233 r=$((4 - ($l % 4)))
1234 if [ $r -ne 4 ]; then
1235 ddq if=/dev/zero bs=1 count=$r >> /tmp/fd$$
1236 l=$(($l + $r))
1237 fi
1238 case "$i:$INITRD" in
1239 *rootfs.gz:*rootfs.gz,*) continue # loram
1240 esac
1241 len="$len $l"; l=0
1242 done
1243 rdadrs=${RDADRS:-$(((($syssize*16)+0x1F0000) & -4096))}
1244 words2bin $(($rdadrs & 0xFFFF)) $(($rdadrs >> 16)) | ddq \
1245 conv=notrunc bs=1 seek=536 count=4 of=/tmp/fd$$
1246 fi
1247 n=$(echo $len | wc -w)
1248 if [ $((494 - $(get 494 /tmp/fd$$))) -ge $(($n * 4)) ]; then
1249 i=$(($(get 494 /tmp/fd$$)))
1250 bytes2bin $(($i + ($n*4) - 256)) | ddq bs=1 conv=notrunc \
1251 seek=496 count=1 of=/tmp/fd$$
1252 else
1253 i=$(($pos + 0x1FC - ($n*4)))
1254 bytes2bin $(($i % 256)) $((i / 256)) 252 | ddq bs=1 \
1255 conv=notrunc seek=494 count=3 of=/tmp/fd$$
1256 s=$(($i - 2*$(echo "$SIZES" | wc -w)))
1257 p=$(($s - $(ifmemcode | wc -c)))
1258 ifmemcode | ddq bs=1 conv=notrunc seek=$p of=/tmp/fd$$
1259 words2bin $SIZES | ddq bs=1 conv=notrunc seek=$s of=/tmp/fd$$
1260 bytes2bin 154 $(($p%256)) $(($p/256)) 0 144 | \
1261 ddq bs=1 conv=notrunc seek=60 of=/tmp/fd$$
1262 fi
1263 for r in $len ; do
1264 words2bin $(($r & 0xFFFF)) $(($r >> 16)) | ddq conv=notrunc \
1265 bs=1 seek=$i count=4 of=/tmp/fd$$
1266 i=$(($i + 4))
1267 done
1268 split -b 1440k /tmp/fd$$ fd$$
1269 rm -f /tmp/fd$$
1270 n=1; i=0; r=0
1271 set -- $len
1272 ls fd$$* | while read file ; do
1273 if [ $i -gt $(($1+$base)) ]; then
1274 shift
1275 r=$(($r+100)); n=0; i=0; base=0
1276 fi
1277 ddq of=$file bs=18k seek=80 count=0
1278 i=$(($i+1474560))
1279 printf "mv %s fd%03d.img\n" $file $(($r+$n))
1280 n=$(($n+1))
1281 done | sh
1282 du -ch $PWD/fd???.img
1285 quit()
1287 umount -d $media
1288 rmdir $media
1289 ${1:-exit}
1292 infoiso()
1294 isoinfo -d -i "$ISO" > /tmp/isoinfo$$
1295 if [ -x "$(which iso2exe)" ]; then
1296 echo "----"
1297 iso2exe -l "$ISO"
1298 fi >> /tmp/isoinfo$$
1299 if [ "$1" ]; then
1300 cat /tmp/isoinfo$$
1301 else
1302 $DIALOG --clear \
1303 --title " Info ISO " \
1304 --textbox /tmp/isoinfo$$ 0 0
1305 fi
1306 rm -f /tmp/isoinfo$$
1309 isotitle()
1311 echo "$(blkid "$ISO" | sed 's/.*LABEL="\([^"]*\).*/\1/') $(stat \
1312 -c %y $media/.|sed 's/ .*//') $(basename "$ISO")"
1315 ISO="${1:-/dev/null}"
1316 [ -z "$(isiso 2> /dev/null)" ] && echo "Usage : $0 file.iso" && exit 1
1317 media=/tmp/media$$
1318 mkdir -p $media
1319 mount -o loop,ro "$ISO" $media
1321 if [ "$2" == "list" ]; then
1322 sed '/^\$(.*") \\/!d;s/^\$(\(.*\)").*/\1"/' $0 | while read line; do
1323 eval $line
1324 echo
1325 done | sed '/^$/d;/"usbkey"/d'
1326 quit
1327 fi
1328 if grep -q "^$2()" $0; then
1329 exe=$2
1330 shift 2
1331 if [ -n "$(eval $(grep "\"$exe\"" $0 | sed \
1332 '/^\$/!d;s/.(\(.*\)[\t ]*".*"[\t ]*".*/\1/'))" ]; then
1333 isotitle
1334 grep "\"$exe\"" $0 | sed '/^\$/!d;s/.*"[\t ]*"\(.*\)".*/\1/'
1335 echo ----
1336 $exe "$@"
1337 fi
1338 quit
1339 fi
1341 while true; do
1342 cat > /tmp/dialog$$ <<EOT
1343 $DIALOG --clear \
1344 --title " $(isotitle) " \
1345 --menu "" -2 70 0 \
1346 $(cdfile 'README*' "readme" "Show the README file") \
1347 $(gotcustomconf "getcustomconf" "Get custom config") \
1348 $(gotisomd5 "isomd5" "Check the ISO image") \
1349 $(cdfile 'md5sum*' "md5" "Check the ISO files") \
1350 $(cdfile 'sha*sum*' "sha" "Check the ISO files") \
1351 $(xfile isoinfo "infoiso" "ISO image info") \
1352 $(cdfilex boot/bzImage "bootiso" "Boot the ISO image") \
1353 $(burnable "burniso" "Burn the ISO image") \
1354 $(blankable "blankcd" "Blank the CD/DVD") \
1355 $(gotposixovl "install" "Hard disk installation (UMSDOS way)") \
1356 $(gotposixovl "installtaz" "Hard disk installation (TAZUSB way)") \
1357 $(gotposixovlzip "inst2zip" "ZIP installation archive (UMSDOS way)") \
1358 $(gotposixovlzip "insttaz2zip" "ZIP installation archive (TAZUSB way)") \
1359 $(xfile tazusb "usbkey" "USB key read/write installation") \
1360 $(ishybrid "usbbootkey" "USB boot key (read only)") \
1361 $(hasflavinfo "showfavinfo" "Show flavor extra info") \
1362 $(xfile tazlito "flavor" "Get flavor file") \
1363 $(cdfile isolinux.cfg "floppyset" "Boot floppy set") \
1364 $(hastazboot "tazboot" "Get tazboot.exe Linux loader") \
1365 $(cdexe boot/bzImage "bzimage" "Get linux DOS/EXE file") \
1366 $(cdexe 'memtest*' "memtest" "Get Memtest86 DOS/EXE file") \
1367 $(cdfilef 'memtest*' "fdmemtest" "Create a Memtest86 boot floppy") \
1368 $(cdfilex 'memtest*' "runmemtest" "Start Memtest86") \
1369 $(cdexe '?pxe' "pxe" "Get SliTaz Web boot DOS/EXE utility") \
1370 $(cdfilef '?pxe' "fdpxe" "Create a SliTaz Web boot floppy") \
1371 $(cdfilex '?pxe' "runpxe" "Start the SliTaz Web boot utility") \
1372 $(misspkg "missing" "Install packages to get more options") \
1373 $(menuitem "quit" "Quit this utility")
1374 EOT
1375 exec 3>&1
1376 value=$(. /tmp/dialog$$ 2>&1 1>&3)
1377 retval=$?
1378 exec 3>&-
1379 rm -f /tmp/dialog$$
1380 [ $retval -eq 0 ] || quit
1381 $value
1382 done